#include "class_Iscrizione.h"
#include <iostream>
#include <cstring>
#include <cstdlib>
using namespace std;

void Iscrizione::init() {
  testa = NULL;
}

void Iscrizione::visualizza() {
  cout<<"Atleti iscritti:"<<endl;
  for(elem*q = testa; q!= NULL; q=q->pun)
    cout<<q->nome<< " , " << q->pettorale << endl;	
  cout<<endl;
}

bool Iscrizione::aggiungi(const char* nome, int pettorale) {
   elem* q, *p, *r;
  //controllo se nome  gia' inserito nella lista
  for(q = testa; q!= NULL; q=q->pun) {
     if ((strcmp(q->nome, nome)==0)||(q->pettorale == pettorale))
      return false;
  }

  //inserisco nome in fondo
  for(q=testa; q!= NULL; q=q->pun) 
     p=q;
  
  r = new elem;
  strcpy(r->nome, nome);
  r->pettorale=pettorale;
  r->pun = NULL;
  if(q==testa)
    testa=r;
  else 
    p->pun = r;
  return true;
}

// SECONDA PARTE (PER CASA)

bool Iscrizione::cerca(const char* nome) {
  for(elem*q = testa; q!= NULL; q=q->pun) {
    if(strcmp(q->nome, nome)==0)
      return true;
  }
  return false;
}

bool Iscrizione::elimina(const char* nome) {
  elem* p, *q;
  for(q = testa; (q!= NULL) && (strcmp(q->nome, nome)!=0); q=q->pun)
    p=q;
  
  if (q==NULL)
    return false;

  if(q==testa) // eliminazione in testa
    testa=q->pun; 	
  else  
    p->pun = q->pun; 

  delete q;
  return true;
}

